var FillAnalyze = {};
(function () {
    String.prototype.trim = function () {
        return this.replace(/(^\s*)|(\s*$)/g, "");
    };

    FillAnalyze.checkFillAnswer = function (myAnswer, sourceAnswer) {
        var reg = /\/+/g
        var arrSourceAnswer = sourceAnswer.split(reg);
        var len = arrSourceAnswer.length;
        for (var i = 0; i < len; i++) {
            if (blurMatch(arrSourceAnswer[i], myAnswer)) {
                return true;
            }
        }
        return false;
    };

    function blurMatch(checkAnswer, rightAnswer) {
        var re = /^[\!|\@|\#|\$|\%|\^|\&|\*|\(|\)|\{|\}|\?|\.|\。|\<|\>|\`|\~|\=|\+|\-|\_|\;|\:|\,|\，|\'|\"|\‘|\’|\“|\”]+$/;
        var blurAnswer = checkAnswer.toLowerCase().trim();
        rightAnswer = rightAnswer.toLowerCase().trim();
        var blurLastChar = blurAnswer.charAt(blurAnswer.length - 1);
        var rightLastChar = rightAnswer.charAt(rightAnswer.length - 1);
        var c = blurAnswer.substr(blurAnswer.length - 1, 1);
        if (re.test(c)) {
            blurAnswer = blurAnswer.substr(0, blurAnswer.length - 1);
        }
        c = rightAnswer.substr(rightAnswer.length - 1, 1);
        if (re.test(c)) {
            rightAnswer = rightAnswer.substr(0, rightAnswer.length - 1);
        }
        if (blurAnswer.indexOf("'") != -1 || rightAnswer.indexOf("'") != -1 || blurAnswer.indexOf(".") != -1 || rightAnswer.indexOf(".") != -1) {
            blurAnswer = replaceAbbreviation(blurAnswer);
            rightAnswer = replaceAbbreviation(rightAnswer);
        }

        var tempArr = blurAnswer.split(" ");
        var blurArr = [];
        var rightArr = [];
        for (var i = 0; i < tempArr.length; i++) {
            var s = tempArr[i];
            if (s != "") {
                blurArr.push(s);
            }
        }
        tempArr = [];
        tempArr = rightAnswer.split(" ");
        for (i = 0; i < tempArr.length; i++) {
            var s2 = tempArr[i];
            if (s2 != "") {
                rightArr.push(s2);
            }
        }
        if (blurArr.length != rightArr.length) {
            return false;
        }
        for (i = 0; i < blurArr.length; i++) {
            if (blurArr[i] != rightArr[i]) {
                return false;
            }
        }
        return true;
    };

    function replaceAbbreviation(s) {
        if (s == "shall not") {
            s = "shan't";
        }
        if (s == "will not") {
            s = "won't";
        }
        if (s == "cannot") {
            s = "can't";
        }
        var re1 = /(\W)shall(\W+)not(\W)/g;
        var re2 = /(\W)will(\W+)not(\W)/g;

        s = s.replace(re1, " shan't ");
        s = s.replace(re2, " won't ");

        s = s.split(" is ").join("'s ");
        s = s.split(" am ").join("'m ");
        s = s.split(" not ").join("n't ");
        s = s.split(" are ").join("'re ");
        s = s.split(" should ").join("'d ");
        s = s.split(" would ").join("'d ");
        s = s.split(" had ").join("'d ");
        s = s.split(" will ").join("'ll ");
        s = s.split(" has ").join("'s ");
        s = s.split(" have ").join("'ve ");

        s = s.split("mr ").join("mr. ");
        s = s.split("mrs ").join("mrs. ");
        s = s.split("ms ").join("ms. ");
        s = s.split("miss ").join("miss. ");
        s = s.split("dr ").join("dr. ");
        s = s.split("cannot").join("can't");

        var re3 = /(\W)not$/;
        s = s.replace(re3, "n't");
        var re4 = /(\W)is$/;
        s = s.replace(re4, "'s");
        var re5 = /(\W)am$/;
        s = s.replace(re5, "'m");
        var re6 = /(\W)are$/;
        s = s.replace(re6, "'re");
        var re7 = /(\W)should$/;
        s = s.replace(re7, "'d");
        var re8 = /(\W)would$/;
        s = s.replace(re8, "'d");
        var re9 = /(\W)had$/;
        s = s.replace(re9, "'d");
        var re10 = /(\W)will$/;
        s = s.replace(re10, "'ll");
        var re11 = /(\W)has$/;
        s = s.replace(re11, "'s");
        var re12 = /(\W)have$/;
        s = s.replace(re12, "'ve");
        return s;
    }
})();