(function(win, doc){

var ua = navigator.userAgent,
	isIOS = /iphone|ipad|ipod/i.test(ua),
	isAndroid = /android/i.test(ua);

// usage:
// __jsBridge.on("echoCallback", function(userInfo){
// 	console.log(userInfo);
// });
// __jsBridge.send("echo", {user:"alex", coin:100, isLogin:true});

var jsBridge = {
	_callbacks: {},

	//send message to webview
	send: function(name, userInfo){
		if(isIOS){
			this._sendToIOS(name, userInfo);
		}else{
			this._sendToAndroid(name, userInfo);
		}
	},

	//trigger message from webview
	trigger: function(name, userInfo){
		var list = this._callbacks[name];

		if(list){
			if(typeof(userInfo) == 'string') userInfo = JSON.parse(userInfo);
			for(var i =0, l = list.length; i < l; i++){
				list[i](userInfo);
			}
		}
	},

	//listen message from webview
	on: function(name, callback){
		if(!this._callbacks[name]) this._callbacks[name] = [];
		this._callbacks[name].push(callback);
	},

	//unlisten message
	un: function(name, callback){
		var len = arguments.length;
		if(len == 1){
			delete this._callbacks[name];
		}else if(len > 1){
			var list = this._callbacks[name];
			for(var i = 0, l = list.length; i < l; i++){
				if(list[i] == callback){
					list.splice(i, 1);
					break;
				}
			}
			if(list.length == 0) this._callbacks[name];
		}
	},

	//-(BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
	//public boolean shouldOverrideUrlLoading(WebView view,String url)
	_sendToIOS: function(name, userInfo){		
		var url = 'jsbridge://' + name + '|' + JSON.stringify(userInfo);
		window.location.href = url;
	},

	//webview.addJavascriptInterface(new Object(){}, "__androidBridge");
	_sendToAndroid: function(name, userInfo){
		if(win.__androidBridge && win.__androidBridge.call){
			win.__androidBridge.call(name, userInfo.toString());
		}
	}
};

win.__jsBridge = jsBridge;

})(window, document);

