(function (win, doc) {

    var QuestionRenderer = {
        _templates: { },

        getTemplate: function (typeId) {
            var templateFn = this._templates[typeId];
            if (!templateFn) {
                var tmpl = doT.template(HCP.$(typeId).innerHTML);
                templateFn = this._templates[typeId] = tmpl;
            }
            return templateFn;
        },

        clearRenderQuestion: function (container) {
            container.innerHTML = "";
        },

        HTMLDecode: function (str) {
            var temp = document.createElement("div");
            temp.innerHTML = str;
            var output = temp.innerText || temp.textContent;
            temp = null;
            return output.replace("\n", "");
        },
        audioPlay: function (obj) {
            var control = obj.parentNode.getElementsByClassName("icon_start")[0];
            control.setAttribute("class", "icon_stop");
        },
        audioTimeupdate: function (obj) {
            var curProgress = obj.parentNode.getElementsByClassName("line_progress")[0].childNodes[0];
            var seekData = obj.currentTime / obj.duration * 100;
            curProgress.style.width = Math.ceil(seekData) + "%";
        },
        audioPause: function (obj) {
            var control = obj.parentNode.getElementsByClassName("icon_stop")[0];
            control.setAttribute("class", "icon_start");
        },
        pauseAllAudios: function () {
            try {
                var audios = doc.getElementsByTagName('audio');
                for (var i = 0; i < audios.length; i++) {
                    audios[i].pause();
                }
            } catch (e) {
            }
        },
        renderQuestion: function (question, container, i) {
            var questId = "question-" + question["QuestionID"];
            var questCopy = HCP.mix({ }, question);
            questCopy.num = i;
            questCopy.name = question["QuestionID"];

            questCopy.imgStatus = question["ContextImage"] ? "" : "hide";
            questCopy.audioStatus = question["ContextAudio"] ? "" : "hide";
            questCopy.answerStatus = question["Solution"] ? "" : "hide";

            var questBodyFn, options;
            switch (question["Type"]) {
                case 1:
                    if (question["OptionsImage"]) {
                        questBodyFn = this.getTemplate("question-image-choice-tmpl");
                    } else {
                        questBodyFn = this.getTemplate("question-choice-tmpl");
                    }
                    break;
                case 2:
                    questBodyFn = this.getTemplate("question-fillblank-tmpl");
                    break;
            }
            if (question["OptionsImage"]) {
                options = HCP.mix([ ], question["OptionsImage"]);
                options.SourcePath = question["SourcePath"];
            } else {
                options = HCP.mix([ ], question["Options"]);
                options.dotStatus = "hide";
                if (question["OptionsAudio"]) {
                    options.audios = [];
                    options.audios = HCP.mix([ ], question["OptionsAudio"]);
                    options.SourcePath = question["SourcePath"];
                } else {
                    options.optionAudioStatus = "no-audio";
                }
            }

            options.name = questId;
            options.OptionSys = HCP.mix([ ], question["Answer"]);
            options.OptionUser = HCP.mix([ ], question["UserAnswer"]);

            questCopy.body = questBodyFn(options);
            //get question html
            var templateFn = this.getTemplate("question-tmpl");
            var html = templateFn(questCopy);
            var elem = document.createElement("figure");
            elem.setAttribute("id", questId);
            elem.setAttribute("class", "question");
            elem.innerHTML = html;
            container.appendChild(elem);

            if (question["ContextImage"] && question["OptionsImage"]) {
                elem.getElementsByClassName("question-img")[0].setAttribute("class", "question-img");
            }
            if (question["OptionsAudio"]) {
                var tmpAudios = elem.getElementsByClassName("link-audio");

                if (tmpAudios && tmpAudios.length > 0) {
                    for (var n = 0; n < tmpAudios.length; n++) {
                        var ta = tmpAudios[n], audioItem, iconStart;
                        ta.addEventListener("click", function (e) {
                            audioItem = this.getElementsByTagName("audio")[0];
                            iconStart = this.getElementsByClassName("icon-audio")[0];
                            if (audioItem.paused) {
                                audioItem.play();
                            } else {
                                audioItem.pause();
                            }
                        });
                    }
                }
            }
            if (question["ContextAudio"]) {
                var contextAudios = elem.getElementsByClassName("link_b_audio");
                var lineProgress = document.getElementById('line_progress_' + question["QuestionID"]);
                var curProgress = document.getElementById('cur_progress_' + question["QuestionID"]);
                var Allseek = (lineProgress.style.width).replace("px", "");
                var seekData;
                for (var n = 0; n < contextAudios.length; n++) {
                    var ta = contextAudios[n];
                    var audioItem = ta.getElementsByTagName("audio")[0];
                    var control = ta.getElementsByClassName("icon_start")[0];
                    ta.addEventListener("click", function (e) {
                        if (audioItem.paused) {
                            audioItem.play();
                        } else {
                            audioItem.pause();
                        }
                    });
                }

            }

            switch (question["Type"]) {
                case 1:
                    // 单选题
                    var optionElems = elem.getElementsByClassName("question-option li");
                    var sys_answer;
                    sys_answer = elem.getElementsByClassName("question-option-item")[question["Answer"] - 1];
                    user_answer = elem.getElementsByClassName("question-option-item")[question["UserAnswer"] - 1];
                    var icon_ele = elem.getElementsByClassName("question-option-txt")[i];
                    if (question["UserAnswer"] != undefined && question["UserAnswer"] != "") {
                        if (question["UserAnswer"] == question["Answer"]) {
                            user_answer.setAttribute("class", "true-option");
                        } else {
                            user_answer.setAttribute("class", "false-option");
                            sys_answer.setAttribute("class", "true-option");
                        }
                        if (question["Options"]) {
                            var elem = document.createElement("span");
                            elem.setAttribute("class", "ml10");
                            elem.innerHTML = "(正确答案)";
                            sys_answer.appendChild(elem);
                        }
                    } else {
                        sys_answer.setAttribute("class", "true-option");
                    }
                    break;
                case 2:
                    // 填空题
                    var option_sys, option_user;
                    option_sys = elem.getElementsByClassName("question-option-sys");
                    option_user = elem.getElementsByClassName("question-option-user");
                    for (var k = 0; k < options.OptionSys.length; k++) {
                        sys = option_sys[k];
                        user = option_user[k];
                        if (FillAnalyze.checkFillAnswer(options.OptionUser[k], options.OptionSys[k])) {
                            sys.setAttribute("class", "question-option-sys green");
                            user.setAttribute("class", "question-option-user hide");
                        } else {
                            user.setAttribute("class", "question-option-user red");
                            sys.setAttribute("class", "question-option-sys green");
                        }
                    }
                    break;
            }

        }
    };

    HCP.QuestionRenderer = QuestionRenderer;

})(window, document);
